indexing

	description:

		"XPath error value types and codes"

	library: "Gobo Eiffel XPath Library"
	copyright: "Copyright (c) 2004, Colin Adams and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2004/12/03 11:32:07 $"
	revision: "$Revision: 1.5 $"

class XM_XPATH_ERROR_TYPES

inherit

	UC_SHARED_STRING_EQUALITY_TESTER

feature -- Access

	Static_error: INTEGER is 1
	Type_error: INTEGER is 2
	Dynamic_error: INTEGER is 3

feature -- Status report

	is_valid_error_code (an_error_code: STRING): BOOLEAN is
			-- Is `an_error_code' valid?
		require
			error_code_not_void: an_error_code /= Void
		do
			Result := error_codes.has (an_error_code)
		end

feature {NONE} -- Implementation

	error_codes: DS_HASH_SET [STRING] is
			-- All known standard error codes
		once
			create Result.make (209)
			Result.set_equality_tester (string_equality_tester)
			Result.put ("XP0001")
			Result.put ("XP0002")
			Result.put ("XP0003")
			Result.put ("XP0004")
			Result.put ("XP0005")
			Result.put ("XP0006")
			Result.put ("XP0007")
			Result.put ("XP0008")
			Result.put ("XP0017")
			Result.put ("XP0018")
			Result.put ("XP0019")
			Result.put ("XP0020")
			Result.put ("XP0021")
			Result.put ("XP0029")
			Result.put ("XP0050")
			Result.put ("XP0051")
			Result.put ("DMTY0001")
			Result.put ("FOER0000")
			Result.put ("FOAR0001")
			Result.put ("FOCA0001")
			Result.put ("FOCA0002")
			Result.put ("FOCA0003")
			Result.put ("FOCA0004")
			Result.put ("FOCA0005")
			Result.put ("FOCH0001")
			Result.put ("FOCH0002")
			Result.put ("FOCH0003")
			Result.put ("FOCH0004")
			Result.put ("FODC0001")
			Result.put ("FODC0002")
			Result.put ("FODC0003")
			Result.put ("FODC0004")
			Result.put ("FODC0005")
			Result.put ("FODT0001")
			Result.put ("FODT0002")
			Result.put ("FODT0003")
			Result.put ("FONC0001")
			Result.put ("FONS0003")
			Result.put ("FONS0004")
			Result.put ("FONS0005")
			Result.put ("FORG0001")
			Result.put ("FORG0002")
			Result.put ("FORG0003")
			Result.put ("FORG0004")
			Result.put ("FORG0005")
			Result.put ("FORG0006")
			Result.put ("FORG0007")
			Result.put ("FORG0008")
			Result.put ("FORG0009")
			Result.put ("FORX0001")
			Result.put ("FORX0002")
			Result.put ("FORX0003")
			Result.put ("FORX0004")
			Result.put ("FOTY0011")
			Result.put ("FOTY0012")
			Result.put ("XT0010")
			Result.put ("XT0020")
			Result.put ("XT0030")
			Result.put ("XT0040")
			Result.put ("XT0050")
			Result.put ("XT0060")
			Result.put ("XT0070")
			Result.put ("XT0080")
			Result.put ("XT0090")
			Result.put ("XT0100")
			Result.put ("XT0110")
			Result.put ("XT0120")
			Result.put ("XT0130")
			Result.put ("XT0140")
			Result.put ("XT0150")
			Result.put ("XT0165")
			Result.put ("XT0170")
			Result.put ("XT0180")
			Result.put ("XT0190")
			Result.put ("XT0200")
			Result.put ("XT0210")
			Result.put ("XT0220")
			Result.put ("XT0260")
			Result.put ("XT0270")
			Result.put ("XT0280")
			Result.put ("XT0290")
			Result.put ("XT0300")
			Result.put ("XT0310")
			Result.put ("XT0320")
			Result.put ("XT0330")
			Result.put ("XT0340")
			Result.put ("XT0350")
			Result.put ("XT0360")
			Result.put ("XT0370")
			Result.put ("XT0380")
			Result.put ("XT0410")
			Result.put ("XT0420")
			Result.put ("XT0430")
			Result.put ("XT0440")
			Result.put ("XT0450")
			Result.put ("XT0490")
			Result.put ("XT0510")
			Result.put ("XT0520")
			Result.put ("XT0530")
			Result.put ("XT0540")
			Result.put ("XT0550")
			Result.put ("XT0560")
			Result.put ("XT0570")
			Result.put ("XT0580")
			Result.put ("XT0590")
			Result.put ("XT0600")
			Result.put ("XT0610")
			Result.put ("XT0620")
			Result.put ("XT0630")
			Result.put ("XT0640")
			Result.put ("XT0650")
			Result.put ("XT0660")
			Result.put ("XT0670")
			Result.put ("XT0680")
			Result.put ("XT0690")
			Result.put ("XT0700")
			Result.put ("XT0710")
			Result.put ("XT0720")
			Result.put ("XT0730")
			Result.put ("XT0740")
			Result.put ("XT0760")
			Result.put ("XT0770")
			Result.put ("XT0780")
			Result.put ("XT0800")
			Result.put ("XT0805")
			Result.put ("XT0810")
			Result.put ("XT0820")
			Result.put ("XT0815")
			Result.put ("XT0830")
			Result.put ("XT0850")
			Result.put ("XT0860")
			Result.put ("XT0870")
			Result.put ("XT0880")
			Result.put ("XT0890")
			Result.put ("XT0900")
			Result.put ("XT0910")
			Result.put ("XT0920")
			Result.put ("XT0930")
			Result.put ("XT0940")
			Result.put ("XT0950")
			Result.put ("XT0955")
			Result.put ("XT0960")
			Result.put ("XT0970")
			Result.put ("XT0975")
			Result.put ("XT0980")
			Result.put ("XT0990")
			Result.put ("XT1000")
			Result.put ("XT1015")
			Result.put ("XT1030")
			Result.put ("XT1035")
			Result.put ("XT1040")
			Result.put ("XT1060")
			Result.put ("XT1070")
			Result.put ("XT1080")
			Result.put ("XT1090")
			Result.put ("XT1100")
			Result.put ("XT1120")
			Result.put ("XT1130")
			Result.put ("XT1140")
			Result.put ("XT1145")
			Result.put ("XT1150")
			Result.put ("XT1160")
			Result.put ("XT1170")
			Result.put ("XT1180")
			Result.put ("XT1190")
			Result.put ("XT1200")
			Result.put ("XT1205")
			Result.put ("XT1220")
			Result.put ("XT1260")
			Result.put ("XT1270")
			Result.put ("XT1280")
			Result.put ("XT1290")
			Result.put ("XT1300")
			Result.put ("XT1310")
			Result.put ("XT1320")
			Result.put ("XT1350")
			Result.put ("XT1360")
			Result.put ("XT1370")
			Result.put ("XT1380")
			Result.put ("XT1390")
			Result.put ("XT1400")
			Result.put ("XT1410")
			Result.put ("XT1420")
			Result.put ("XT1430")
			Result.put ("XT1450")
			Result.put ("XT1460")
			Result.put ("XT1480")
			Result.put ("XT1490")
			Result.put ("XT1500")
			Result.put ("XT1505")
			Result.put ("XT1510")
			Result.put ("XT1515")
			Result.put ("XT1520")
			Result.put ("XT1530")
			Result.put ("XT1540")
			Result.put ("XT1550")
			Result.put ("XT1555")
			Result.put ("XT1560")
			Result.put ("XT1570")
			Result.put ("XT1580")
			Result.put ("XT1590")
			Result.put ("XT1600")
			Result.put ("XT1610")
			Result.put ("XT1620")
			Result.put ("XT1630")
			Result.put ("XT1640")
			Result.put ("XT1650")
			Result.put ("XT1660")
			Result.put ("XT1665")
		end

end
	
