indexing

	description:

		"Compiled instructions that produce text output"

	library: "Gobo Eiffel XSLT Library"
	copyright: "Copyright (c) 2004, Colin Adams and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2004/09/27 13:41:41 $"
	revision: "$Revision: 1.4 $"

class XM_XSLT_COMPILED_TEXT

inherit

	XM_XSLT_TEXT_CONSTRUCTOR
		redefine
			item_type
		end

	XM_XPATH_RECEIVER_OPTIONS

	XM_XPATH_SHARED_NODE_KIND_TESTS

creation

	make

feature {NONE} -- Initialization

	make (an_executable: XM_XSLT_EXECUTABLE; disabled: BOOLEAN) is
			-- Establish invariant.
		require
			executable_not_void: an_executable /= Void
		do
			executable := an_executable
			instruction_name := "text"
			create children.make (0)
			make_expression_instruction
			set_cardinality_exactly_one
			if disabled then
				receiver_options := Disable_escaping
			end
		ensure
			executable_set: executable = an_executable
		end

feature -- Access

	instruction_name: STRING
			-- Name of instruction, for diagnostics
	
	item_type: XM_XPATH_ITEM_TYPE is
			-- Data type of the expression, when known
		do
			Result := text_node_kind_test
		end

feature -- Comparison

	same_expression (other: XM_XPATH_EXPRESSION): BOOLEAN is
			-- Are `Current' and `other' the same expression?
		do
			Result := False
			todo ("same_expression", True)
		end

feature -- Optimization

	type_check (a_context: XM_XPATH_STATIC_CONTEXT) is
			-- Perform static type checking
		do
			do_nothing
		end

feature -- Evaluation

	process_leaving_tail (a_context: XM_XSLT_EVALUATION_CONTEXT) is
			-- Execute `Current', writing results to the current `XM_XPATH_RECEIVER'.
		local
			a_string: STRING
		do
			a_string := expanded_string_value (a_context)
			a_context.transformer.current_receiver.notify_characters (a_string, receiver_options)
			last_tail_call := Void
		end

feature {NONE} -- Implementation

	receiver_options: INTEGER
			-- Receiver options

end
	
